c     Copyright (C) 2008-2009 Vincent Eymet
c
c     Planet_EMC is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 3, or (at your option)
c     any later version.

c     Planet_EMC is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with Planet_EMC; if not, see <http://www.gnu.org/licenses/>
c
      subroutine get_nlines(kfile,stringp_file,nl)
      implicit none
c
c     Purpose: to return the number of lines the specified file contains
c
c     Inputs:
c       + kfile: the file whose number of lines has to be retrieved
c       + stringp_file: file that will be temporarily used by the system
c         to store the number of lines of "kfile". It must be explicitely
c         specified because of parallelization (different processes might
c         want to access the same file at the same moment, the name specified
c         in "stringp_file" must therefore be unique for a given process).
c
c     Outputs:
c       + nl: number of lines in "kfile"
c     
      logical ex
      integer strlen,nl
      character*100 kfile
      character*200 command
      character*100 stringp_file

      inquire(file=kfile(1:strlen(kfile)),exist=ex)
      if (.not.ex) then
         nl=0
         goto 123
      endif

c     Number of lines in the specified data file
      command="wc -l < "//kfile(1:strlen(kfile))//" > "//
     &     stringp_file(1:strlen(stringp_file))
      call exec(command)

      open(10,file=stringp_file(1:strlen(stringp_file)))
      read(10,*) nl
      close(10)

 123  continue

      return
      end



      subroutine stringp_file_name(pindex,string,stringp_file)
      implicit none
c     
c     Purpose: to set "stringp_file" that is used by routine "get_nlines"
c     
c     Inputs:
c       + pindex: index of the process that calls this routine
c       + string: base to "stringp_file"
c
c     Outputs:
c       + stringp_file: file that will be temporarily used by "get_nlines"
c
      include 'formats.inc'
      integer strlen,pindex
      character*100 string
      character*3 pindex_ch3
      character*100 stringp_file

      call num2str3(pindex,pindex_ch3)
      stringp_file=string(1:strlen(string))//
     &     '_'//
     &     pindex_ch3(1:strlen(pindex_ch3))

      return
      end
