c     Copyright (C) 2009 Vincent Eymet
c
c     "satellite" is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 3, or (at your option)
c     any later version.

c     This software is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with the present software; if not, see <http://www.gnu.org/licenses/>
c
      subroutine look_for_errors(dim,Psat,Pground,op_alpha,rspace)
      implicit none
      include 'max.inc'
      include 'param.inc'
c     
c     Purpose: to check there is no known error or mistake in data definition
c

c     I/O
      integer dim
      double precision Psat(1:Nmat_mx)
      double precision Pground(1:Nmat_mx)
      double precision op_alpha,rspace
c     temp
      integer los
      integer strlen
      character*100 label
      label='subroutine look_for_errors'
      
c     check satellite coordinates
      if (Psat(1).le.rspace) then
         write(*,*) 'Bad input parameter'
         write(*,*) 'Satellite altitude=',
     &        (Psat(1)-Pground(1))/1.0D+3,' km'
         write(*,*) 'is lower than'
         write(*,*) 'altitude at space level=',
     &        (rspace-Pground(1))/1.0D+3,' km'
         stop
      endif
      if ((Psat(2).lt.-pi/2.0D+0).or.(Psat(2).gt.pi/2.0D+0)) then
         write(*,*) 'Bad input parameter'
         write(*,*) 'Satellite latitude'
         stop
      endif
      if ((Psat(3).lt.0.0D+0).or.(Psat(3).gt.2.0D+0*pi)) then
         write(*,*) 'Bad input parameter'
         write(*,*) 'Satellite longitude'
         stop
      endif

c     check coordinates of "Pground"
      if ((Pground(2).lt.-pi/2.0D+0).or.
     &     (Pground(2).gt.pi/2.0D+0)) then
         write(*,*) 'Bad input parameter'
         write(*,*) 'point latitude'
         stop
      endif
      if ((Pground(3).lt.0.0D+0).or.
     &     (Pground(3).gt.2.0D+0*pi)) then
         write(*,*) 'Bad input parameter'
         write(*,*) 'point longitude'
         stop
      endif

c     check detector angle
      if ((op_alpha.lt.0.0D+0).or.(op_alpha.gt.pi/2.0D+0)) then
         write(*,*) 'Bad input parameter'
         write(*,*) 'detector observation angle'
         stop
      endif

c     check line of sight between Psat and Pground
      call check_los(dim,Pground,Psat,los)
      if (los.eq.0) then
         write(*,*) 'Error from ',label(1:strlen(label)),' :'
         write(*,*) 'No line of sight possible between satellite and'
         write(*,*) 'position on ground'
         stop
      endif

      return
      end
